From 2432ad51526388bd26e2823d82df3fce80537b8b Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Thu, 2 Apr 2020 17:04:25 +0200
Subject: [PATCH] alpes-maritimes-2018: mes-associations template (#41279)

---
 static/alpes-maritimes-2018/config.json                       | 4 ++--
 .../alpes-maritimes-2018/combo/json/mes-associations.html     | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

diff --git a/static/alpes-maritimes-2018/config.json b/static/alpes-maritimes-2018/config.json
index 3b98af51..0c7568d5 100644
--- a/static/alpes-maritimes-2018/config.json
+++ b/static/alpes-maritimes-2018/config.json
@@ -187,17 +187,17 @@
                   ],
                   "cache_duration": 1,
                   "name": "Sous-dossier Handicap",
                   "varnames": ["dossier"],
                   "url": "{{ passerelle_url }}atos-genesys/{% firstof slug genesys_slug \"genesys-prod\" %}/dossiers?NameID={{user_nameid}}&link_id={{ dossier }}"
               },
               "informations-association": {
                   "cache_duration": 1,
-                  "name": "Informations de l'association",
+                  "name": "Informations de l'organisme",
                   "form": [
                     {
                       "label": "Identifiant du connecteur",
                       "varname": "slug",
                       "required": true
                     }
                   ],
                   "additional-data": [
@@ -205,17 +205,17 @@
                      "url": "{{ passerelle_url }}astregs/{{ slug }}/get-contact?contact_id={{ json.data.EncodeKeyContact }}"
                     }
                   ],
                   "varnames": ["association_id"],
                   "url": "{{ passerelle_url }}astregs/{{ slug }}/get-association-by-id?association_id={{ association_id }}&NameID={{ user_nameid }}"
               },
               "mes-associations": {
                   "cache_duration": 1,
-                  "name": "Mes associations",
+                  "name": "Mes organismes",
                   "form": [
                     {
                       "label": "Identifiant du connecteur",
                       "varname": "slug",
                       "required": true
                     }
                   ],
                   "url": "{{ passerelle_url }}astregs/{{ slug }}/links?NameID={{ user_nameid }}"
diff --git a/templates/variants/alpes-maritimes-2018/combo/json/mes-associations.html b/templates/variants/alpes-maritimes-2018/combo/json/mes-associations.html
index 969c97c5..38d7af04 100644
--- a/templates/variants/alpes-maritimes-2018/combo/json/mes-associations.html
+++ b/templates/variants/alpes-maritimes-2018/combo/json/mes-associations.html
@@ -1,20 +1,20 @@
 <div class="cell textcell pink-header">
   <div>
-    <h3>Mes associations</h3>
+    <h3>Mes organismes</h3>
     {% if json.data %}
     {% for association in json.data %}
     <h4 style="color: #001c76;">{{ association.text }}</h4>
     <p>
       <a href="{{ portal_url }}informations-de-lassociation/?association_id={{association.id}}">Voir les informations</a> -
       <a href="{{ eservices_url }}associations/modification-des-informations-relatives-a-mon-association/?association_id={{association.id}}&cancelurl={{ portal_url }}associations/">Modifier les informations</a> -
       <a href="{{ eservices_url }}associations/enlever-une-association-a-mon-profil/?association_id={{association.id}}&cancelurl={{ portal_url }}associations/">Enlever de mon profil</a>
     </p>
     <p>
       <a class="turquoise-button" href="{{ eservices_url }}associations/demande-de-subvention/?association_id={{association.id}}&cancelurl={{ portal_url }}associations/\">Faire une demande de subvention</a>
     </p>
     {% endfor %}
     {% else %}
-    <p>Vous devez cliquer sur le bouton <a href="{{ eservices_url }}associations/ajouter-une-association-a-mon-profil/?cancelurl={{ portal_url }}associations/">ajouter une association à mon profil</a> pour poursuivre.</p>
+    <p>Vous devez cliquer sur le bouton <a href="{{ eservices_url }}associations/ajouter-une-association-a-mon-profil/?cancelurl={{ portal_url }}associations/">ajouter un organisme à mon profil</a> pour poursuivre.</p>
     {% endif %}
   </div>
 </div>
-- 
2.25.1